
namespace clucene.net {

using System;

	public class _CL_p_p_lucene__index__IndexReaderArray : IDisposable 
	{
		private IntPtr swigCPtr;
		protected bool swigCMemOwn;

		internal _CL_p_p_lucene__index__IndexReaderArray(IntPtr cPtr, bool cMemoryOwn) 
		{
			swigCMemOwn = cMemoryOwn;
			swigCPtr = cPtr;
		}

		internal static IntPtr getCPtr(_CL_p_p_lucene__index__IndexReaderArray obj) 
		{
			return (obj == null) ? IntPtr.Zero : obj.swigCPtr;
		}

		~_CL_p_p_lucene__index__IndexReaderArray() 
		{
			Dispose();
		}

		public virtual void Dispose() 
		{
			if(swigCPtr != IntPtr.Zero && swigCMemOwn) 
			{
				swigCMemOwn = false;
				libCLcsharpPINVOKE.delete__CL_p_p_lucene__index__IndexReaderArray(swigCPtr);
			}
			swigCPtr = IntPtr.Zero;
			GC.SuppressFinalize(this);
		}

		public int length() 
		{
			return libCLcsharpPINVOKE._CL_p_p_lucene__index__IndexReaderArray_length(swigCPtr);
		}

		public void init(int len) 
		{
			libCLcsharpPINVOKE._CL_p_p_lucene__index__IndexReaderArray_init(swigCPtr, len);
		}

		public IndexReader get(int idx) 
		{
			IntPtr cPtr = libCLcsharpPINVOKE._CL_p_p_lucene__index__IndexReaderArray_get(swigCPtr, idx);
			return (cPtr == IntPtr.Zero) ? null : new IndexReader(cPtr, false);
		}

		public void set(IndexReader a, int i) 
		{
			libCLcsharpPINVOKE._CL_p_p_lucene__index__IndexReaderArray_set(swigCPtr, IndexReader.getCPtr(a), i);
		}

		public _CL_p_p_lucene__index__IndexReaderArray(IndexReader[] val) : this(libCLcsharpPINVOKE.new__CL_p_p_lucene__index__IndexReaderArray(), true) 
		{
			int size=val.Length;
			this.init(size);
			for ( int i=0;i<size;i++ )
				this.set(val[i],i);
		}

		public IndexReader[] toArray()
		{
			int len = this.length();
			IndexReader[] ret = new IndexReader[len];
			for ( int i=0;i<len;i++ )
				ret[i]=get(i);
			return ret;
		}
	}
}
